Subject: Re: [PATCH net-next v4] net: qualcomm: rmnet: Add side band flow control support

From: Jakub Kicinski <[email-masked]>
Date: Tue, 10 Oct 2023 11:21:59 -0700

On Tue, 10 Oct 2023 09:23:12 -0600 Subash Abhinov Kasiviswanathan (KS)
wrote:
> > I'm not sure what you mean. Qdiscs can form hierarchies.
> > You put mq first and then whatever child qdisc you want for individual
> > queues.  
> 
> There is no userspace interface exposed today currently to invoke 
> netif_tx_stop_queue(dev, queue) / netif_tx_wake_queue(dev, queue). The 
> API itself can only be invoked within kernel.
> 
> I was wondering if it would be acceptable to add a user accessible 
> interface in core networking to stop_queue / wake_queue instead of the 
> driver.

Maybe not driver queue control but if there's no qdisc which allows
users to pause from user space, I think that would be a much easier
sale.

That said the flow of the whole thing seems a bit complex.
Can't the driver somehow be notified by the device directly?
User space will suffer from all sort of wake up / scheduling
latencies, it'd be better if the whole sleep / wake thing was 
handled in the kernel.